<!--
Licensed to the Apache Software Foundation (ASF) under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  The ASF licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing,
software distributed under the License is distributed on an
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, either express or implied.  See the License for the
specific language governing permissions and limitations
under the License.
-->
# Apache Crunch - Simple and Efficient MapReduce Pipelines
---

> *Apache Crunch (incubating)* is a Java library for writing, testing, and
> running MapReduce pipelines, based on Google\'s FlumeJava. Its goal is to make
> pipelines that are composed of many user-defined functions simple to write,
> easy to test, and efficient to run.

---

Running on top of [Hadoop MapReduce](http://hadoop.apache.org/mapreduce/), Apache
Crunch provides a simple Java API for tasks like joining and data aggregation
that are tedious to implement on plain MapReduce. For Scala users, there is also
Scrunch, an idiomatic Scala API to Crunch.

## Documentation

  * [Introduction to Apache Crunch](intro.html)
  * [Introduction to Scrunch](scrunch.html)
  * [Current Limitations and Future Work](future-work.html)

## Disclaimer

Apache Crunch is an effort undergoing incubation at [The Apache Software Foundation
(ASF)](http://apache.org/) sponsored by the [Apache Incubator PMC](http://incubator.apache.org/).
Incubation is required of all newly accepted projects until a further review
indicates that the infrastructure, communications, and decision making process
have stabilized in a manner consistent with other successful ASF projects.
While incubation status is not necessarily a reflection of the completeness or
stability of the code, it does indicate that the project has yet to be fully
endorsed by the ASF.
